<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8"/>
    <title>DR-BIP Trace View</title>
    <link rel="stylesheet" href="style.css">

	  <script src="https://d3js.org/d3.v5.min.js"></script>
    <script src="d3-hypergraph.js"></script>



  </head>
  <body>

    <div id="dataset">
        <select id="data-selector">
        <option value=""> -- Choose Trace</option>
        </select>
    </div>
    <div id="status-bar">test
    </div>
    <div id="interaction-graph">
    </div>
    <div id="my-canvas">
      <svg id="svg-canvas" overflow="scroll" width="100%" height="100%" style="background:white;" >
        <g></g>
      </svg>
    </div>
    <div id="my-snapshot" class="panel">
    </div>
    <div id="my-state" class="panel">
    </div>
    <div id="custom-panel" class="panel">
    </div>

    <!--<script src="tasks.json"></script>-->


    <script src="hyper.js"></script>
    <script src="rendertrace.js"></script>
    <script src="models.js"></script>
    <!--<script src="platoon.json"></script>-->

    <script>
    function statusMessage(s) {
      var sb = d3.select('#status-bar');
      sb.style('display', 'block');
      sb.html(s);
      window.setTimeout(function(){
        sb.html("");
        sb.style('display', 'none');
      }, 5000);
    }

    function myround(num) {
      return  Math.round((num + Number.EPSILON) * 100) / 100;
    }

    function getPbox() {
      var w_x =  window.innerWidth;
      var w_y =  window.innerHeight;
      return {left: 50, right: w_x - 50, top: 25, bottom: w_y - 150};
    }

    var activeDataset = "";
    var data;

    var car_gradient = null;
    var modelinfo = models[""];



    d3.csv("traces.txt").then(function(d){
      for(i in d) {
        var file = d[i].traces.replace(".json","");
        if(file == "") continue;
        var selector = d3.selectAll('#data-selector');
        var opt = selector.append("option");
        opt.html(file);
        opt.attr("value", file);
      }
    });

    d3.selectAll('#data-selector').on("change", function(){

      var dset = d3.select(this).node().value;
      if(dset == "") return;
      if(dset == activeDataset) return;
      else {
        activeSet = dset;



        d3.json("traces/" + dset + ".json").then(function(d){
          data = d;
          modelname = data.package;
          if(models[modelname] != null)
            modelinfo = models[modelname];
          else
            modelinfo = models[""];

          modelinfo.post(data);
          //loadData(d);
          customPlot();
          statusMessage("Loaded dataset: " + dset + " (s: rule sequence, h: heatmap, p: score graph)");

          d3.select('#data-selector').node().blur();
        });

        //d3.select(this).style("display", "none");
      }
    });

    function feature_norm(d, ival, bounds) {
      if(d.length == 0) return null;


      var min  = d[0];
      var max  = d[0];
      var mean = d[0];
      var collapsed = false;


      if(bounds && bounds.length == 2) {
        min = bounds[0];
        max = bounds[1];
      }
      else {
        for(i = 1; i < d.length; i++) {
          min = Math.min(min, d[i]);
          max = Math.max(max, d[i]);
        }


        collapsed = min == max;

        if(bounds && bounds.length == 1) {
          var mid = (min + max) * 1.0 / 2;
          if(max - min < bounds) {
            var half= bounds[0] * 1.0;
            min = mid - half;
            max = mid + half;
          }
        }
        else {
          min = min - Math.abs(max);
          max = 2*max;
        }
      }

      var diff = (max - min) * 1.0;
      var sum = 0.0;



      for(i = 0; i < d.length; i++) {
        d[i] = ((d[i] - min) * 1.0) / (diff);
        sum  += d[i];
      }

      var mean = sum / d.length;

      var dev = 0.0;
      if(ival == null) {
        if(!collapsed) {
          for(i = 0; i < d.length; i++)
             dev += Math.pow(d[i] - mean, 2);
          dev = Math.sqrt(dev / (d.length - 1));
        }
      }
      else {
        imin = ((ival[0] - min) * 1.0) / diff;
        imax = ((ival[1] - min) * 1.0) / diff;


        for(i = 0; i < d.length; i++) {
           v = 0.0;
           if(d[i] < imin) v = imin - d[i];
           else if(imax < d[i]) v = d[i] - imax;

           dev += Math.pow(v, 2);
        }
        if(d.length > 1)
          dev = Math.sqrt(dev / (d.length -1));
      }


      return ([min, max, mean, dev]);
    }
    d3.select("#custom-panel").on("click", function(){
      d3.select("#custom-panel").style("display", "none").html("");
      d3.select("#my-canvas").style("display", "block");
    });
    function customPlot() {
      d3.select('#my-canvas').style('display', 'none');
      d3.selectAll('.panel').style('display', 'none');
      d3.select('#custom-panel').style('display', 'block').html("");
      xsvg = d3.select("#custom-panel").append("svg");
      xroot= xsvg.append("g");


      //ssvg.attr('style', 'background:white');
      xsvg.attr('width', '100%');
      xsvg.attr('height', '100%');
      xsvg.attr('overflow', 'scroll');




      var pbox = getPbox();

      x = d3.scaleLinear()
              .domain([0, data.switches[data.switches.length-1].start + 1])
              .range([pbox.left, pbox.right]);
      y = d3.scaleLinear()
              .domain([0, 1])
              .range([pbox.bottom, pbox.top]);


      xsvg.append("g")
            .attr("transform", "translate(0," + pbox.bottom + ")")
            .style("font-size", "14pt")
            .style("font-weight", "bold")
            .call(d3.axisBottom(x));
      xsvg.append("g")
            .attr("transform", "translate("+ pbox.left +", 0)")
            .style("font-size", "14pt")
            .style("font-weight", "bold")
            .call(d3.axisLeft(y));


      var dset = [];

      for(i in data.switches) {
        var s = data.switches[i];
        if(s.type != "DRBIP") continue;
        if(s.snapshot.components.length == 0) continue;
        var score = modelinfo.score(s.snapshot);

        dset.push({"x1": s.start, "x2": s.end, "score" : score});
      }

      var pcolor = modelinfo.score_info.colors;
      var sname  = modelinfo.score_info.labels;
      /*
      xsvg.append('g')
        .selectAll("dot")
        .data(dset)
        .enter()
        .append("circle")
          .attr("cx", function (d) { return x(d.x); } )
          .attr("cy", pbox.bottom + 25)
          .attr("r", 3)
          .style("fill", "black");
          */

      for(j = 0; j < modelinfo.score_info.n; j++) {
        xsvg.append("path")
        .datum(dset)
        .attr("fill", "none")
        .attr("stroke", pcolor[j])
        .attr("stroke-width", 1.5)
        .attr("d", d3.line()
          .x(function(d) { return x(d.x1) })
          .y(function(d) { return y(d.score[j]) })
        );


        xsvg.append("line")
        .attr("x1", pbox.left + 20 + 300*j)
        .attr("x2", pbox.left + 40 + 300*j)
        .attr("y1", pbox.bottom + 40)
        .attr("y2", pbox.bottom + 40)
        .attr("stroke", pcolor[j]);

        xsvg.append("text")
        .attr("x", pbox.left + 75 + 300*j)
        .attr("y", pbox.bottom + 45)
        .attr("fill", pcolor[j])
        .attr("stroke", "1px")
        .text(sname[j]);

      }
        /*
      xsvg.append("path")
      .datum(dset)
      .attr("fill", "none")
      .attr("stroke", "orange")
      .attr("stroke-width", 1.5)
      .attr("d", d3.line()
        .x(function(d) { return x(d.x) })
        .y(function(d) { return y(d.score[2]) })
      );*/


    }



    </script>
      <footer>
    </footer>
  </body>
</html>
